import os

class FsLoader:
    def __init__ (self):
        self.fs = []
    
    def add (self, fs):
        self.fs.append (fs)
    
    def debug (self):
        print (self.fs)
    
    def __len__ (self):
        return len (self.fs)
    
    def __getitem__ (self, key):
        for f in self.fs:
            if f.name == key:
                return f
        return None
    
loader = FsLoader ()

class FsOption:
    def __init__ (self, name=''):
        self.name = name
        self.wig = None
        self.value = None
        self.visible = True
        self.fs = False

class Fs:
    def __init__ (self):
        #register plugin        
        self.name = 'Generic FS'
        self.options = {}
        o = self.add_option ('mountpoint')
        o.fs = True
        self.obj = {}
    
    def add_option (self, name):
        o = FsOption (name)
        self.options[name] = o
        return o
    
    def get_options (self):
        return self.options                

    def umount (self):
        s = "fusermount -u %s" % (self.options['mountpoint'].value)
        ret = os.system (s)
        if ret == 0:
            return (True, 'ok')
        else:
            return (False, 'Unknown error running fusermount')
