from fs import Fs
from fs import FsOption
from fs import loader
import pexpect

def new ():
    return SSHFs ()

class SSHFs (Fs):
    def __init__ (self):
        Fs.__init__ (self)
        self.name = 'SSHFs'
        o = self.add_option ('host')        
        o = self.add_option ('username')
        o = self.add_option ('password')
        o.visible = False
        self.obj['new'] = new

    def mount (self):
        v = self.options["host"].value.split (":")
        host = v[0]
        try:
            port = int (v[1])
        except:
            port = 22
        uri = '%s@%s:' % (self.options['username'].value, self.options['host'].value)
        s = 'sshfs -p %d %s %s' % (port, uri, self.options['mountpoint'].value)
        print "Exec", s
        
        try:
            child = pexpect.spawn (s)
        except pexpect.ExceptionPexpect, e:
            return (False, str (e))
        #do login
        while child.isalive ():
            index = child.expect (['Password:', 'password:', 
                                   '(yes/no)', 
                                   'Permission denied',
                                   'Connection reset by peer',
                                   pexpect.EOF, pexpect.TIMEOUT
                                   ])
            if index <= 1:
                print "Insert password"
                child.sendline (self.options['password'].value)
                child.readline ()
            elif index == 2:
                child.sendline ('yes')
            elif index <= 4:
                print "Permission denied"
                return (False, "Permission denied")
            elif index == 5:
                print child.before
                print "EOF"
                return (True, 'ok')
            elif index == 6:
                print "TIMEOUT"
                return (False, "Timeout")
        
        return (False, "unknown error")

#FIXME: enable only if it's installed (or install this file with the plugin..)
sshfs = SSHFs ()
loader.add (sshfs)